<?php
// define dynamix runtime name
define('RUNTIME', 'ADMIN');



error_reporting(0);



// Load essential libraries
require_once('components/core.lib.php');
// Load libraries
require_once('components/common.lib.php');
require_once('components/configsystem.class.php');
require_once('components/database/databasesystem.class.php');
require_once('components/database/queryprovider.class.php');
require_once('components/database/commandprovider.class.php');
require_once('components/entitysystem.class.php');
require_once('components/entities.lib.php');
require_once('components/mediasystem.class.php');
require_once('components/modulesystem.class.php');
require_once('components/themesystem.class.php');
// Load administrator libraries
require_once('components/admin/adminsystem.class.php');
require_once('components/admin/adminkernel.lib.php');



register_shutdown_function('ShutdownAdmin');



$Data = array();
$Data['SiteUrl'] = '';

PrepareSiteUrl();


// Get request as row POST data
$RequestRowPost = file_get_contents("php://input");
if (empty($RequestRowPost))
	ReturnToHome();


$Response = '';
$RequestCollection = array();
$Status = '';


// Load request as XML format
$XDocRequest = new DOMDocument();
if (@$XDocRequest->loadXML($RequestRowPost) == FALSE)
	ErrorResponse(10);

// Check request is a valid Exsense Dynamix request
$XElementRoot = $XDocRequest->documentElement;
if ($XElementRoot->nodeName != 'ExsenseDynamixRequest')
	ErrorResponse(11);
	
// Retrieve xml request to request collection
foreach ($XElementRoot->childNodes as $nodeRequest)
{
	if ($nodeRequest->nodeType != XML_ELEMENT_NODE)
		continue;
	
	if ($XElementRoot->getElementsByTagName($nodeRequest->nodeName)->length > 1)
		$RequestCollection[$nodeRequest->nodeName][] = $nodeRequest->nodeValue;
	else
		$RequestCollection[$nodeRequest->nodeName] = $nodeRequest->nodeValue;
}

unset($XElementRoot);
unset($XDocRequest);

// Check request
if (GetRequest() == '')
	ErrorResponse('9');


// Instantiate setting management class
$Settings = new SettingsManagement();
if ($Settings->HasError())
	ErrorResponse('20');
$Settings->Load();

// Check Authentication
if (RetrieveRequest('Username') != $Settings->Username || sha1(RetrieveRequest('Password')) != $Settings->Password)
	ErrorResponse(12);
else
{
	unset($RequestCollection['Username']);
	unset($RequestCollection['Password']);
}


// Check conditions for instantiate components,
// Prevent instantiate some of components for some of requests
$Database = NULL;
$Entity = NULL;
$ThisPage = NULL;
if (GetRequest() != 'Signin' && 
	GetRequest() != 'ConfigurationGet' && 
	GetRequest() != 'ConfigurationSet' && 
	GetRequest() != 'ConfigurationReset' &&
	GetRequest() != 'MaintenanceDatabaseSetup' &&
	GetRequest() != 'ModuleList' &&
	GetRequest() != 'ModulePanelEdit' &&
	GetRequest() != 'MediaList' &&
	GetRequest() != 'MediaAdd' &&
	GetRequest() != 'MediaDelete' &&
	GetRequest() != 'MediaView' &&
	GetRequest() != 'ThemeElements' &&
	GetRequest() != 'ThemeElementView' &&
	GetRequest() != 'ThemeElementEdit' &&
	GetRequest() != 'ThemeTemplateView' &&
	GetRequest() != 'ThemeTemplateEdit')
{
	// Check database settings are valid
	if (!CheckDatabaseSettings())
		ErrorResponse(23);
	
	// Instantiate database management class
	$Database = new DatabaseManagement($Settings->DatabaseType, $Settings->DatabaseHost, $Settings->DatabaseUsernameAdmin, $Settings->DatabasePasswordAdmin);
	if ($Database->HasError())
		ErrorResponse(30, $Database->ErrorMessage());
	// Select the database
	$Database->SelectDatabase($Settings->DatabaseName);
	if ($Database->HasError())
		ErrorResponse(35, $Database->ErrorMessage());
	
	// Instantiate entity management class
	$Entity = new EntityManagement();
	
	// Instantiate this page entity class
	$ThisPage = new ThisPageClass();
}


// Instantiate module management class
// Instantiate module management class for module requests
$Modules = NULL;
if (GetRequest() == 'ModuleList' ||
	GetRequest() == 'ModulePanelEdit')
{
	$Modules = new ModuleManagement();
	if ($Modules->HasError())
		ErrorResponse(50);
	$Modules->Load();
}


// Instantiate theme system class
$ThemeSystem = NULL;
if (GetRequest() == 'ThemeElements')
{
	$ThemeSystem = new ThemeSystem();
	if ($ThemeSystem->HasError())
		ErrorResponse(80);
	$ThemeSystem->Load();
}


StatusOK();


// Process request
switch (GetRequest())
{
	case 'Signin':
		ActionProvider::Signin();
		break;
	case 'ConfigurationGet':
		ActionProvider::ConfigurationGet();
		break;
	case 'ConfigurationSet':
		ActionProvider::ConfigurationSet();
		break;
	case 'ConfigurationReset':
		ActionProvider::ConfigurationReset();
		break;
	case 'MaintenanceDatabaseSetup':
		ActionProvider::MaintenanceDatabaseSetup();
		break;
	case 'PageList':
		ActionProvider::PageList();
		break;
	case 'PageAdd':
		ActionProvider::PageAdd();
		break;
	case 'PageView':
		ActionProvider::PageView();
		break;
	case 'PageEdit':
		ActionProvider::PageEdit();
		break;
	case 'PageDelete':
		ActionProvider::PageDelete();
		break;
	case 'MenuAdd':
		ActionProvider::MenuAdd();
		break;
	case 'MenuList':
		ActionProvider::MenuList();
		break;
	case 'MenuEdit':
		ActionProvider::MenuEdit();
		break;
	case 'MenuDelete':
		ActionProvider::MenuDelete();
		break;
	case 'MenuOrdering':
		ActionProvider::MenuOrdering();
		break;
	case 'PanelAdd':
		ActionProvider::PanelAdd();
		break;
	case 'PanelList':
		ActionProvider::PanelList();
		break;
	case 'PanelView':
		ActionProvider::PanelView();
		break;
	case 'PanelEdit':
		ActionProvider::PanelEdit();
		break;
	case 'PanelDelete':
		ActionProvider::PanelDelete();
		break;
	case 'CommentList':
		ActionProvider::CommentList();
		break;
	case 'CommentDelete':
		ActionProvider::CommentDelete();
		break;
	case 'ModuleList':
		ActionProvider::ModuleList();
		break;
	case 'ModulePanelEdit':
		ActionProvider::ModulePanelEdit();
		break;
	case 'MediaList':
		ActionProvider::MediaList();
		break;
	case 'MediaAdd':
		ActionProvider::MediaAdd();
		break;
	case 'MediaDelete':
		ActionProvider::MediaDelete();
		break;
	case 'MediaView':
		ActionProvider::MediaView();
		break;
	case 'ThemeElements':
		ActionProvider::ThemeElements();
		break;
	case 'ThemeElementView':
		ActionProvider::ThemeElementView();
		break;
	case 'ThemeElementEdit':
		ActionProvider::ThemeElementEdit();
		break;
	case 'ThemeTemplateView':
		ActionProvider::ThemeTemplateView();
		break;
	case 'ThemeTemplateEdit':
		ActionProvider::ThemeTemplateEdit();
		break;
	case 'PostList':
		ActionProvider::PostList();
		break;
	case 'PostAdd':
		ActionProvider::PostAdd();
		break;
	case 'PostEdit':
		ActionProvider::PostEdit();
		break;
	case 'PostView':
		ActionProvider::PostView();
		break;
	case 'PostDelete':
		ActionProvider::PostDelete();
		break;
	default:
		ErrorResponse(9);
		break;
}


unset($RequestCollection);

PerformResponse();

?>