<?php

// Perform response to output
// Parameters: OK|Failed (enum(string))
function PerformResponse()
{
	global $Response;
	global $Status;

	$Response = '<?xml version="1.0" encoding="utf-8" ?>' . "\n" . "<ExsenseDynamixResponse Status=\"$Status\">" . $Response . '</ExsenseDynamixResponse>';
	header('Content-type: text/xml');
	echo $Response;
	exit();
}



// Perform error response
// Parameters: int , string
function ErrorResponse($errno, $errmessage = '')
{
	global $Response;
	
	$Response = CreateElement($errno, 'Error') . CreateElement($errmessage, 'Message');
	StatusFailed();
	PerformResponse();
}



// Define error handler function
function ErrorHandlerAdmin($errno, $errstr, $errfile, $errline)
{
	ErrorResponse(0, 'A internal and undefined error occured. Error Message: ' . $errstr . '. File: ' . $errfile . '. Line: ' . $errline . '. Error Number: ' . $errno);
	
	return true;
}



// Shutdown admin function
function ShutdownAdmin()
{
	$error = error_get_last();
	if ($error != NULL)
	{
		if ($error['type'] == E_ERROR || 
			$error['type'] == E_CORE_ERROR || 
			$error['type'] == E_COMPILE_ERROR || 
			$error['type'] == E_USER_ERROR ||
			$error['type'] == E_PARSE)
			ErrorHandlerAdmin($error['type'], $error['message'], $error['file'], $error['line']);
	}
}



// Create XML element
// Parameters: string, string, assoc array
// Return: string
function CreateElement($value = '', $name = 'Item', $attcollection = NULL)
{
	$attribs = '';
	if (is_array($attcollection))
	{
		foreach ($attcollection as $attKey=>$attValue)
		{
			$attribs .= ' ' . $attKey . '="' . $attValue . '"';
		}
	}
	
	return "<$name$attribs>$value</$name>";
}



// Create xml value as CDATA format
// Parameters: string
// Return: string
function CreateCDataValue($value)
{
	return "<![CDATA[$value]]>";
}



// Set status to OK
function StatusOK()
{
	global $Status;
	$Status = 'OK';
}



// Set status to Failed
function StatusFailed()
{
	global $Status;
	$Status = 'FAILED';
}



// Get request string
// Return: string
function GetRequest()
{
	return RetrieveRequest('Request');
}



// Get and retrieve request
// Parameters: string
// Return: string
function RetrieveRequest($request)
{
	global $RequestCollection;

	if (isset($RequestCollection[$request]))
		return $RequestCollection[$request];
	else
		return '';
}



// Get and retrieve request as nested array
// Parameters: string
// Return: Array | NULL
function RetrieveRequestArray($request)
{
	global $RequestCollection;
	
	$arrayCollection = NULL;
	
	if (isset($RequestCollection[$request]))
	{
		$arrayCollection = $RequestCollection[$request];
		if (is_array($arrayCollection) == TRUE)
			return $arrayCollection;
		else
		{
			$arrayCollection = array();
			$arrayCollection[] = $RequestCollection[$request];
			return $arrayCollection;
		}
	}
	else
		return NULL;
}

?>