<?php

// define Exsense Dynamix CMS Version
define('VERSION', '1.8.0.5');



// define Master handler page
define('MASTERHANDLER', 'index.php');

// define Setting directory
define('SETTINGSDIR', 'settings/');

// define Config file address
define('CONFIGFILE', SETTINGSDIR . 'config.xml');

// define Module config file address
define('MODULECONFIG', SETTINGSDIR . 'module.xml');
// define Moduel directory
define('MODULEDIR', 'modules/');

// define Media directory
define('MEDIADIR', 'media/');
// define Media subdirectories
define('MEDIAPICTURESDIR', MEDIADIR . 'pictures/');
define('MEDIASOUNDSDIR', MEDIADIR . 'sounds/');
define('MEDIAMOVIESDIR', MEDIADIR . 'movies/');
define('MEDIAFLASHESDIR', MEDIADIR . 'flashes/');
define('MEDIADOCUMENTSDIR', MEDIADIR . 'documents/');
define('MEDIAFILESDIR', MEDIADIR . 'files/');

// define Resources directory
define('RESOURCESDIR', 'resources/');
// define Resource subdirectories
define('THEMEDIR', RESOURCESDIR . 'theme/');
define('FORMSDIR', RESOURCESDIR . 'forms/');
define('PAGESDIR', RESOURCESDIR . 'pages/');
define('SCRIPTSDIR', RESOURCESDIR . 'scripts/');
define('TEMPLATESDIR', RESOURCESDIR . 'templates/');

// define Theme elements file
define('THEMEELEMENTSFILE', SETTINGSDIR . 'theme-elements.xml');





// Return to home page
function ReturnToHome()
{
	global $Data;
	
	$ptn = array();
	$ptn[0] = '/{URL}/';
	$ptn[1] = '/{TITLE}/';
	
	$rlc = array();
	$rlc[0] = $Data['SiteUrl'] . 'index.php';
	$rlc[1] = 'home page';

	echo RegexTokenReplacer('pages/return.html', $ptn, $rlc);
	exit();
}



// Reqular Expression token replacer
// Parameters: string , array , array
// Return: string
function RegexTokenReplacer($subject, $pattern, $replacement)
{
	return preg_replace($pattern, $replacement, file_get_contents($subject));
}



// Prepare site base url
function PrepareSiteUrl()
{
	global $Data;

	$Data['SiteUrl'] = SiteUrl();
}



// Create site url
function SiteUrl()
{
	$strServer = $_SERVER['SERVER_NAME'];                    // [ OBSOLETED ] // $_SERVER['HTTP_HOST']
	$strPath = rtrim(dirname($_SERVER['PHP_SELF']), '/\\');  // [ OBSOLETED ] // $_SERVER['SCRIPT_NAME'] // $_SERVER['REQUEST_URI']
	
	return sprintf("http://%s%s/", $strServer, $strPath);
}



// Convert string to boolean
// Parameters: string
// Return: boolean
function StringToBoolean($value)
{
	if (strtolower($value) == 'true')
		return TRUE;
	else
		return FALSE;
}



// Convert boolean to string
// Parameters: boolean
// Return: string
function BooleanToString($value)
{
	if ($value === TRUE)
		return 'true';
	else
		return 'false';
}



// Convert boolean to int
// Parameters: boolean
// Return: int
function BooleanToInt($value)
{
	if ($value === TRUE)
		return 1;
	else
		return 0;
}



?>