<?php

// Command provider for database
class CommandProvider
{
	// Execute a single command and query
	// Parameters: string
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function Command($strCommand)
	{
		global $Database;
		
		$Database->QueryExecute($strCommand);
		return !$Database->QueryHasError();
	}
	
	
	
	// Execute multi command and query
	// Parameters: string Array
	// Return: boolean Array
	public static function MultiCommand($queryCollection)
	{
		global $Database;
		
		return $Database->MultiQuery($queryCollection);
	}
	




	
	
	
	
	
	// Increase page conter and insert to database
	// Parameters: int , int
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function IncreasePageCounter($pageID, $counter)
	{
		return self::Command("UPDATE `page` SET `Counter` = $counter WHERE `ID` = $pageID");
	}
	
	
	
	// Increase post conter and insert to database
	// Parameters: int , int
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function IncreasePostCounter($postID, $counter)
	{
		return self::Command("UPDATE `post` SET `Counter` = $counter WHERE `ID` = $postID");
	}
	
	
	
	// Insert comment to database
	// Parameters: int , string , string , string , string , string(date)
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function InsertComment($pID, $name, $email, $subject, $message, $cdate)
	{
		return self::Command("INSERT INTO `comment` (`ID` , `PageID`, `NamePerson`, `Email`, `Subject`, `Message`, `CreatedDate`) VALUES (NULL , $pID, '$name', '$email', '$subject', '$message', '$cdate')");
	}
	
	
	
	// Add a new page to database
	// Parameters: PageEntity
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function AddPage($page)
	{
		$ipublished = BooleanToInt($page->Published);
		$iallowcommenting = BooleanToInt($page->AllowCommenting);
		$ishowcomments = BooleanToInt($page->ShowComments);
		$ishowsubpages = BooleanToInt($page->ShowSubpages);
		$ishowtitle = BooleanToInt($page->ShowTitle);
		$ishowdescription = BooleanToInt($page->ShowDescription);
		$ishowdate = BooleanToInt($page->ShowDate);
		$ishowauthor = BooleanToInt($page->ShowAuthor);
			
		return self::Command("INSERT INTO `page` (`ID`, `ParentID`, `Name`, `Title`, `Description`, `TextContent`, `CreatedDate`, `ModifiedDate`, `Published`, `Counter`, `AllowCommenting`, `ShowComments`, `ShowSubpages`, `ShowTitle`, `ShowDescription`, `ShowDate`, `ShowAuthor`, `Author`, `MetaDescription`, `MetaKeywords`, `StyleClass`) VALUES (NULL, $page->ParentID, '$page->Name', '$page->Title', '$page->Description', '$page->TextContent', '$page->CreatedDate', '$page->ModifiedDate', $ipublished, 0, $iallowcommenting, $ishowcomments, $ishowsubpages, $ishowtitle, $ishowdescription, $ishowdate, $ishowauthor, '$page->Author', '$page->MetaDescription', '$page->MetaKeywords', '$page->StyleClass')");
	}
	
	
	
	// Edit a page in database
	// Parameters: PageEntity
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function EditPage($page)
	{
		$ipublished = BooleanToInt($page->Published);
		$iallowcommenting = BooleanToInt($page->AllowCommenting);
		$ishowcomments = BooleanToInt($page->ShowComments);
		$ishowsubpages = BooleanToInt($page->ShowSubpages);
		$ishowtitle = BooleanToInt($page->ShowTitle);
		$ishowdescription = BooleanToInt($page->ShowDescription);
		$ishowdate = BooleanToInt($page->ShowDate);
		$ishowauthor = BooleanToInt($page->ShowAuthor);
			
		return self::Command("UPDATE `page` SET `ParentID` = $page->ParentID, `Name` = '$page->Name', `Title` = '$page->Title', `Description` = '$page->Description', `TextContent` = '$page->TextContent', `CreatedDate` = '$page->CreatedDate', `ModifiedDate` = '$page->ModifiedDate', `Published` = $ipublished, `AllowCommenting` = $iallowcommenting, `ShowComments` = $ishowcomments, `ShowSubpages` = $ishowsubpages, `ShowTitle` = $ishowtitle, `ShowDescription` = $ishowdescription, `ShowDate` = $ishowdate, `ShowAuthor` = $ishowauthor, `Author` = '$page->Author', `MetaDescription` = '$page->MetaDescription', `MetaKeywords` = '$page->MetaKeywords', `StyleClass` = '$page->StyleClass' WHERE `ID` = $page->ID");
	}
	
	
	
	// Delete a page in database
	// Parameters: int
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function DeletePage($id)
	{
		return self::Command("DELETE FROM `page` WHERE `ID` = $id");
	}
	
	
	
	// Add a new menu to database
	// Parameters: MenuEntity
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function AddMenu($menu)
	{
		$ipublished = BooleanToInt($menu->Published);
		$iisexternal = BooleanToInt($menu->IsExternal);
		
		return self::Command("INSERT INTO `menu` (`ID`, `MenuGroup`, `Title`, `AltText`, `PageURL`, `Ordering`, `Published`, `IsExternal`) VALUES (NULL , $menu->MenuGroup, '$menu->Title', '$menu->AltText', '$menu->PageURL', $menu->Ordering, $ipublished, $iisexternal)");
	}
	
	
	
	// Edit a menu in database
	// Parameters: MenuEntity
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function EditMenu($menu)
	{
		$ipublished = BooleanToInt($menu->Published);
		$iisexternal = BooleanToInt($menu->IsExternal);
		
		return self::Command("UPDATE `menu` SET `MenuGroup` = $menu->MenuGroup, `Title` = '$menu->Title', `AltText` = '$menu->AltText', `PageURL` = '$menu->PageURL', `Ordering` = $menu->Ordering, `Published` = $ipublished, `IsExternal` = $iisexternal WHERE `ID` = $menu->ID");
	}
	
	
	
	// Delete a menu in database
	// Parameters: int
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function DeleteMenu($id)
	{
		return self::Command("DELETE FROM `menu` WHERE `ID` = $id");
	}
	
	
	
	// Ordering menus in database
	// Parameters: Assoc Array
	// Return: boolean Array
	public static function OrderingMenu($orderCollection)
	{
		$commandCollection = array();
		
		foreach ($orderCollection as $item)
		{
			$commandCollection[] = "UPDATE `menu` SET `Ordering` = $item[Order] WHERE `ID` = $item[ID]";
		}

		return self::MultiCommand($commandCollection);
	}
	
	
	
	// Add a new panel to database
	// Parameters: PanelEntity
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function AddPanel($panel)
	{
		$ishowonsubpages = BooleanToInt($panel->ShowOnSubpages);
		$ishowglobal = BooleanToInt($panel->ShowGlobal);
		
		return self::Command("INSERT INTO `panel` (`ID`, `PageID`, `PanelGroup`, `Title`, `TextContent`, `ShowOnSubpages`, `ShowGlobal`, `StyleClass`) VALUES (NULL , $panel->PageID, $panel->PanelGroup, '$panel->Title', '$panel->TextContent', $ishowonsubpages, $ishowglobal, '$panel->StyleClass')");
	}
	
	
	
	// Edit a panel in database
	// Parameters: PanelEntity
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function EditPanel($panel)
	{
		$ishowonsubpages = BooleanToInt($panel->ShowOnSubpages);
		$ishowglobal = BooleanToInt($panel->ShowGlobal);
		
		return self::Command("UPDATE `panel` SET `PageID` = $panel->PageID, `PanelGroup` = $panel->PanelGroup, `Title` = '$panel->Title', `TextContent` = '$panel->TextContent', `ShowOnSubpages` = $ishowonsubpages, `ShowGlobal` = $ishowglobal, `StyleClass` = '$panel->StyleClass' WHERE `ID` = $panel->ID");
	}
	
	
	
	// Delete a panel in database
	// Parameters: int
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function DeletePanel($id)
	{
		return self::Command("DELETE FROM `panel` WHERE `ID` = $id");
	}
	
	
	
	// Delete page panels in database
	// Parameters: int
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function DeletePagePanels($pageid)
	{
		return self::Command("DELETE FROM `panel` WHERE `PageID` = $pageid");
	}
	
	
	
	// Delete comments in database
	// Parameters: Assoc Array
	// Return: boolean Array
	public static function DeleteComments($commentsCollection)
	{
		$commandCollection = array();
		
		foreach ($commentsCollection as $item)
		{
			$commandCollection[] = "DELETE FROM `comment` WHERE `ID` = $item";
		}

		return self::MultiCommand($commandCollection);
	}
	
	
	
	// Delete page comments in database
	// Parameters: int
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function DeletePageComments($pageid)
	{
		return self::Command("DELETE FROM `comment` WHERE `PageID` = $pageid");
	}
	
	
	
	// Add a new post to database
	// Parameters: PostEntity
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function AddPost($post)
	{
		$ipublished = BooleanToInt($post->Published);
		$ishowauthor = BooleanToInt($post->ShowAuthor);
					
		return self::Command("INSERT INTO `post` (`ID`, `Name`, `Title`, `TextContent`, `CreatedDate`, `ModifiedDate`, `Published`, `Counter`, `ShowAuthor`, `Author`, `MetaDescription`, `MetaKeywords`, `StyleClass`) VALUES (NULL, '$post->Name', '$post->Title', '$post->TextContent', '$post->CreatedDate', '$post->ModifiedDate', $ipublished, 0, $ishowauthor, '$post->Author', '$post->MetaDescription', '$post->MetaKeywords', '$post->StyleClass')");
	}
	
	
	
	// Edit a post in database
	// Parameters: PostEntity
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function EditPost($post)
	{
		$ipublished = BooleanToInt($post->Published);
		$ishowauthor = BooleanToInt($post->ShowAuthor);
			
		return self::Command("UPDATE `post` SET `Name` = '$post->Name', `Title` = '$post->Title', `TextContent` = '$post->TextContent', `CreatedDate` = '$post->CreatedDate', `ModifiedDate` = '$post->ModifiedDate', `Published` = $ipublished, `ShowAuthor` = $ishowauthor, `Author` = '$post->Author', `MetaDescription` = '$post->MetaDescription', `MetaKeywords` = '$post->MetaKeywords', `StyleClass` = '$post->StyleClass' WHERE `ID` = $post->ID");
	}
	
	
	
	// Delete a post in database
	// Parameters: int
	// Return: boolean | returns TRUE on success or FALSE on failure
	public static function DeletePost($id)
	{
		return self::Command("DELETE FROM `post` WHERE `ID` = $id");
	}
	
}

?>