<?php

// Query provider for database
class QueryProvider
{
	// Make page query by page name
	// Parameters: string
	public static function PageQueryWithName($name)
	{
		return "SELECT * FROM `page` WHERE `Name` = '$name' LIMIT 0,1";
	}
	
	
	
	// Make page query by page id
	// Parameters: int
	public static function PageQueryWithID($id)
	{
		return "SELECT * FROM `page` WHERE `ID` = $id LIMIT 0,1";
	}
	
	
	
	// Make post query by post name
	// Parameters: string
	public static function PostQueryWithName($name)
	{
		return "SELECT * FROM `post` WHERE `Name` = '$name' LIMIT 0,1";
	}
	
	
	
	// Make post query by post id
	// Parameters: int
	public static function PostQueryWithID($id)
	{
		return "SELECT * FROM `post` WHERE `ID` = $id LIMIT 0,1";
	}
	
	
	
	// Make database exists query
	// Parameters: string
	public static function DatabaseExists($dbName)
	{
		return "SHOW DATABASES LIKE '$dbName'";
	}
	
	
	
	// Make parent description query
	// Parameters: int
	public static function ParentDescriptionQuery($parentID)
	{
		return "SELECT `Description` FROM `page` WHERE `ID` = $parentID LIMIT 0,1";
	}
	
	
	
	// Make subpage list query by ID sort
	// Parameters: int , bool
	public static function SubpageQuery($pID, $getDescription)
	{
		if ($getDescription == true)
			return "SELECT `Name`, `Title`, `Description` FROM `page` WHERE `ParentID` = $pID ORDER BY `ID`";
		else
			return "SELECT `Name`, `Title` FROM `page` WHERE `ParentID` = $pID ORDER BY `ID`";
	}
	
	
	
	// Make subpage list query by Title sort ascending
	// Parameters: int , bool
	public static function SubpageQuerySortAsc($pID, $getDescription)
	{
		if ($getDescription == true)
			return "SELECT `Name`, `Title`, `Description` FROM `page` WHERE `ParentID` = $pID ORDER BY `Title` ASC";
		else
			return "SELECT `Name`, `Title` FROM `page` WHERE `ParentID` = $pID ORDER BY `Title` ASC";
	}
	
	
	
	// Make subpage list query by Title sort descending
	// Parameters: int , bool
	public static function SubpageQuerySortDesc($pID, $getDescription)
	{
		if ($getDescription == true)
			return "SELECT `Name`, `Title`, `Description` FROM `page` WHERE `ParentID` = $pID ORDER BY `Title` DESC";
		else
			return "SELECT `Name`, `Title` FROM `page` WHERE `ParentID` = $pID ORDER BY `Title` DESC";
	}
	
	
	
	// Make comments list query
	// Parameters: int
	public static function CommentQuery($pID)
	{
		return "SELECT * FROM `comment` WHERE `PageID` = $pID ORDER BY `CreatedDate` DESC";
	}
	
	
	
	// Make menus list query
	public static function MenuQuery()
	{
		return "SELECT * FROM `menu` ORDER BY `Ordering`, `ID`";
	}
	
	
	
	// Make panels list query
	// Parameters: int
	public static function PanelQuery($pID)
	{
		return "SELECT * FROM `panel` WHERE `PageID` = $pID";
	}
	
	
	
	// Make gloabl panels list query
	// Parameters: int
	public static function PanelQueryGlobal($pID)
	{
		return "SELECT * FROM `panel` WHERE `PageID` <> $pID AND `ShowGlobal` = true";
	}
	
	
	
	// Make onsubpage panels list query
	// Parameters: int
	public static function PanelQueryOnsubpage($ppID)
	{
		return "SELECT * FROM `panel` WHERE `ShowGlobal` = false AND `ShowOnSubpages` = true AND `PageID` = $ppID";
	}
	
	
	
	// Make all panels list query
	public static function PanelQueryAll()
	{
		return "SELECT * FROM `panel` ORDER BY `ID`";
	}
	
	
	
	// Make panels list query
	// Parameters: int
	public static function PanelListQuery($pID)
	{
		return "SELECT `ID`, `Title` FROM `panel` WHERE `PageID` = $pID";
	}
	
	
	
	// Make all panels list query
	public static function PanelListQueryAll()
	{
		return "SELECT `ID`, `Title` FROM `panel` ORDER BY `ID`";
	}
	
	
	
	// Make panel list query
	// Parameters: int
	public static function PanelQueryWithID($pID)
	{
		return "SELECT * FROM `panel` WHERE `ID` = $pID LIMIT 0,1";
	}
	
	
	
	// Make navigator query
	// Parameters: int
	public static function NavigatorQuery($pID)
	{
		return "SELECT `ParentID`, `Name`, `Title` FROM `page` WHERE `ID` = $pID LIMIT 0,1";
	}
	
	
	
	// Make search pages query
	// Parameters: string
	public static function SearchPagesQuery($search)
	{
		return "SELECT `Name`, `Title`, `Description` FROM `page` WHERE (`Published` = true) AND (`Title` LIKE '%$search%' OR `Description` LIKE '%$search%' OR `TextContent` LIKE '%$search%')";
	}
	
	
	
	// Make search posts query
	// Parameters: string
	public static function SearchPostsQuery($search)
	{
		return "SELECT `Name`, `Title` FROM `post` WHERE (`Published` = true) AND (`Title` LIKE '%$search%' OR `TextContent` LIKE '%$search%')";
	}
	
	
	
	// Make page list query
	// Parameters: boolean , boolean , boolean , boolean , boolean
	public static function PageListQuery($withID, $withName, $withTitle, $withDescription, $withParentID, $sortDesc)
	{
		$fields = '';
		$order = '';
		
		if ($withID == TRUE)
			$fields .= empty($fields) ? '`ID`' : ',`ID`';
		if ($withName == TRUE)
			$fields .= empty($fields) ? '`Name`' : ',`Name`';
		if ($withTitle == TRUE)
			$fields .= empty($fields) ? '`Title`' : ',`Title`';
		if ($withDescription == TRUE)
			$fields .= empty($fields) ? '`Description`' : ',`Description`';
		if ($withParentID == TRUE)
			$fields .= empty($fields) ? '`ParentID`' : ',`ParentID`';
			
		if ($sortDesc == TRUE)
			$order = 'DESC';
		
		return "SELECT " . $fields . " FROM `page` ORDER BY `ID` " . $order;
	}
	
	
	
	// Make page query by page id for comment feedback
	// Parameters: int
	public static function PageQueryCommentFeedback($id)
	{
		return "SELECT `ID`, `Title`, `AllowCommenting` FROM `page` WHERE `ID` = $id LIMIT 0,1";
	}
	
	
	
	// Make posts count query
	public static function PostsCountQuery()
	{
		return "SELECT COUNT(`ID`) AS `PostsCount` FROM `post`";
	}
	
	
	
	// Make posts list query
	// Parameters: int, int
	public static function PostsListQuery($limit, $offset)
	{
		return "SELECT `ID`, `Name`, `Title`, `TextContent`, `CreatedDate`, `ModifiedDate` FROM `post` WHERE (`Published` = true) ORDER BY `ID` DESC LIMIT $limit OFFSET $offset";
	}
	
	
		
	// Make post list query
	// Parameters: boolean , boolean , boolean , boolean
	public static function PostListQuery($withID, $withName, $withTitle, $sortDesc)
	{
		$fields = '';
		$order = '';
		
		if ($withID == TRUE)
			$fields .= empty($fields) ? '`ID`' : ',`ID`';
		if ($withName == TRUE)
			$fields .= empty($fields) ? '`Name`' : ',`Name`';
		if ($withTitle == TRUE)
			$fields .= empty($fields) ? '`Title`' : ',`Title`';
			
		if ($sortDesc == TRUE)
			$order = 'DESC';
		
		return "SELECT " . $fields . " FROM `post` ORDER BY `ID` " . $order;
	}
	
	
	
	// Make syndication query
	public static function SyndicationQuery()
	{
		return "SELECT `Name`, `Title`, `TextContent`, `Category` FROM `contents` WHERE (`Published` = true) AND (`Name` != 'home') ORDER BY `CreatedDate` DESC";
	}
	
}

?>