<?php

// This Page Entity Class
class ThisPageClass
{
	public $ID;
	public $ParentID;
	public $Name;
	
	// This Page constructor
	function __construct()
	{
		$this->ID = 0;
		$this->ParentID = 0;
		$this->Name = '';
	}
}





// This Post Entity Class
class ThisPostClass
{
	public $ID;
	public $Name;
	
	// This Post constructor
	function __construct()
	{
		$this->ID = 0;
		$this->Name = '';
	}
}





// Page Entity Class
class PageEntity
{
	public $ID;
	public $ParentID;
	public $Name;
	public $Title;
	public $Description;
	public $TextContent;
	public $CreatedDate;
	public $ModifiedDate;
	public $Published;
	public $Counter;
	public $AllowCommenting;
	public $ShowComments;
	public $ShowSubpages;
	public $ShowTitle;
	public $ShowDescription;
	public $ShowDate;
	public $ShowAuthor;
	public $Author;
	public $MetaDescription;
	public $MetaKeywords;
	public $StyleClass;
}





// Post Entity Class
class PostEntity
{
	public $ID;
	public $Name;
	public $Title;
	public $Description;
	public $CreatedDate;
	public $ModifiedDate;
	public $Published;
	public $Counter;
	public $ShowAuthor;
	public $Author;
	public $MetaDescription;
	public $MetaKeywords;
	public $StyleClass;
}





// Subpage Entity Class
class SubpageEntity
{
	public $ID;
	public $ParentID;
	public $Name;
	public $Title;
	public $Description;
}





// Navigator Entity Class
class NavigatorEntity
{
	public $ParentID;
	public $Name;
	public $Title;
}





// Menu Entity Class
class MenuEntity
{
	public $ID;
	public $MenuGroup;
	public $Title;
	public $AltText;
	public $PageURL;
	public $Ordering;
	public $Published;
	public $IsExternal;
}





// Panel Entity Class
class PanelEntity
{
	public $ID;
	public $PageID;
	public $PanelGroup;
	public $Title;
	public $TextContent;
	public $ShowOnSubpages;
	public $ShowGlobal;
	public $StyleClass;
}





// Panel Item Entity Class
class PanelItemEntity
{
	public $ID;
	public $Title;
}





// Comment Entity Class
class CommentEntity
{
	public $ID;
	public $NamePerson;
	public $Email;
	public $Subject;
	public $Message;
	public $CreatedDate;
}





// Post List Item Entity Class
class PostsListItemEntity
{
	public $ID;
	public $Name;
	public $Title;
	public $TextContent;
	public $CreatedDate;
	public $ModifiedDate;
}





// Posts Information Entity Class
class PostsInformationEntity
{
	public $Page;
	public $TotalPages;
	public $Content;
}





// Post List Item Entity Class
class PostListItemEntity
{
	public $ID;
	public $Name;
	public $Title;
}





// Syndication Entity Class
class SyndicationEntity
{
	public $Name;
	public $Title;
	public $TextContent;
	public $Category;
}

?>