<?php



// Temp function
function Temp_()
{
}



// Trace function
function Trace_($text = '')
{
	if (empty($text) == TRUE)
		echo 'TRACE';
	else
		echo $text;
}



// Define error handler function
function ErrorHandler($errno, $errstr, $errfile, $errline)
{
	ShowError('Error', 'Internal Error', 'A internal and undefined error occured.<br />Please contact site administartor and web master.<br /><br /><strong>Error Message:</strong> ' . $errstr . '<br /><strong>File:</strong> ' . $errfile . '<br /><strong>Line:</strong> ' . $errline, $errno);
	return true;
}



// Shutdown function
function Shutdown()
{
	$error = error_get_last();
	if ($error != NULL)
	{
		if ($error['type'] == E_ERROR || 
			$error['type'] == E_CORE_ERROR || 
			$error['type'] == E_COMPILE_ERROR || 
			$error['type'] == E_USER_ERROR ||
			$error['type'] == E_PARSE)
			ErrorHandler($error['type'], $error['message'], $error['file'], $error['line']);
	}
}



// Check is any error occured
function CheckErrorOccured()
{
	global $Settings;
	
	if ($Settings->ErrorReporting != TRUE)
		return;
	
	$error = error_get_last();
	if ($error != NULL)
	{
		if ($error['type'] != E_ERROR && 
			$error['type'] != E_CORE_ERROR &&
			$error['type'] != E_COMPILE_ERROR &&
			$error['type'] != E_USER_ERROR)
		{
			global $Theme;
			global $Output;
			
			$Output['Content'] = TemplateProvider::Error('A internal and undefined error occured.<br />Please contact site administartor and web master.<br /><br /><strong>Error Number:</strong> ' . $error['type'] . '<br /><strong>Error Message:</strong> ' . $error['message'] . '<br /><strong>File:</strong> ' . $error['file'] . '<br /><strong>Line:</strong> ' . $error['line']) . $Output['Content'];
		}
	}
}



// Show error page
// Parameters: string , string , string
function ShowError($title, $pagetitle, $content, $errno = 0)
{
	global $Output;
	
	$ptn = array();
	$ptn[0] = '/{SITETITLE}/';
	$ptn[1] = '/{TITLE}/';
	$ptn[2] = '/{PAGETITLE}/';
	$ptn[3] = '/{CONTENT}/';
	$ptn[4] = '/{ERRORNUMBER}/';
	$ptn[5] = '/{URL}/';
	
	$rlc = array();
	$rlc[0] = !empty($Output['Title']) ? $Output['Title'] : 'Exsense Dynamix';
	$rlc[1] = $title;
	$rlc[2] = $pagetitle;
	$rlc[3] = $content;
	$rlc[4] = $errno;
	$rlc[5] = SiteUrl();

	echo RegexTokenReplacer(SiteUrl() . PAGESDIR . 'error.html', $ptn, $rlc);
	exit(1);
}



// Show message page
// Parameters: string , string , string
function ShowMessage($title, $pagetitle, $content)
{
	global $Output;
	
	$ptn = array();
	$ptn[0] = '/{SITETITLE}/';
	$ptn[1] = '/{TITLE}/';
	$ptn[2] = '/{PAGETITLE}/';
	$ptn[3] = '/{CONTENT}/';
	$ptn[4] = '/{URL}/';
	
	$rlc = array();
	$rlc[0] = !empty($Output['Title']) ? $Output['Title'] : 'Exsense Dynamix';
	$rlc[1] = $title;
	$rlc[2] = $pagetitle;
	$rlc[3] = $content;
	$rlc[4] = SiteUrl();

	echo RegexTokenReplacer(SiteUrl() . PAGESDIR . 'message.html', $ptn, $rlc);
	exit();
}



// Initialize and Reset Request
function InitRequest()
{
	global $RequestType;
	global $Request;
	
	$RequestType = "PAGE";
	$Request = "home";
}



// Prepare and parse HTTP GET request
function PrepareRequest()
{
	global $RequestType;
	global $Request;
	
	$HttpGet = '';
	$HttpGetValue = '';
	
	if (isset($_GET['page']))
	{
		$HttpGet = 'PAGE';
		$HttpGetValue = $_GET['page'];
	}
	else if (isset($_GET['search']))
	{
		$HttpGet = 'SEARCH';
		$HttpGetValue = $_GET['search'];
	}
	else if (isset($_REQUEST['option']))
	{
		$HttpGet = 'OPTION';
		$HttpGetValue = $_REQUEST['option'];
	}
	else if (isset($_REQUEST['post']))
	{
		$HttpGet = 'POST';
		$HttpGetValue = $_REQUEST['post'];
	}
	else if (isset($_REQUEST['posts']))
	{
		$HttpGet = 'POSTS';
		$HttpGetValue = $_REQUEST['posts'];
	}
	else
	{
		foreach ($_GET as $getKey => $getValue)
		{
			if (strtoupper($getKey) == 'PAGE')
			{
				$HttpGet = 'PAGE';
				$HttpGetValue = $getValue;
				break;
			}
			if (strtoupper($getKey) == 'SEARCH')
			{
				$HttpGet = 'SEARCH';
				$HttpGetValue = $getValue;
				break;
			}
			if (strtoupper($getKey) == 'OPTION')
			{
				$HttpGet = 'OPTION';
				$HttpGetValue = $getValue;
				break;
			}
			if (strtoupper($getKey) == 'POST')
			{
				$HttpGet = 'POST';
				$HttpGetValue = $getValue;
				break;
			}
			if (strtoupper($getKey) == 'POSTS')
			{
				$HttpGet = 'POSTS';
				$HttpGetValue = $getValue;
				break;
			}
		}
	}
	
	switch ($HttpGet)
	{
		case 'PAGE':
			$RequestType = 'PAGE';
			$Request = preg_replace("([^a-zA-Z0-9\s-_])", "", strtolower($HttpGetValue));
			break;
		case 'SEARCH':
			$RequestType = 'SEARCH';
			$Request = preg_replace("([^a-zA-Z0-9\s-_])", "", $HttpGetValue);
			break;
		case 'OPTION';
			$RequestType = 'OPTION';
			$Request = preg_replace("([^a-zA-Z0-9])", "", strtolower($HttpGetValue));
			break;
		case 'POST':
			$RequestType = 'POST';
			$Request = preg_replace("([^a-zA-Z0-9\s-_])", "", strtolower($HttpGetValue));
			break;
		case 'POSTS':
			$RequestType = 'POSTS';
			$Request = preg_replace("([^0-9])", "", $HttpGetValue);
			break;
	}
}



// Create a valid internal url with or without url rewriting
// Parameters: string
// Return: string
function CreateInternalUrl($urlName)
{
	global $Settings;

	return ($Settings->UrlRewriting === TRUE ? CreateInternalAddress($urlName) : CreateInternalAddress(MASTERHANDLER . '?page=' . $urlName));
}



// Create a valid internal post url
// Parameters: string
// Return: string
function CreateInternalPostUrl($urlName)
{
	global $Settings;

	return CreateInternalAddress(MASTERHANDLER . '?post=' . $urlName);
}



// Create a valid internal posts list url
// Parameters: int
// Return: string
function CreateInternalPostsListUrl($postPage)
{
	global $Settings;
	
	return CreateInternalAddress(MASTERHANDLER . '?posts=' . $postPage);
}



// Create a valid internal address with or without base url
// Parameters: string
// Return: string
function CreateInternalAddress($url)
{
	global $Settings;
	global $Data;
	
	if (empty($url) === TRUE)
		return $Data['SiteUrl'];
	
	return ($Settings->UseBaseUrl === TRUE ? $Data['SiteUrl'] . $url : $url);
}



// Prepare and get header elements
// Return: string
function PrepareHeaderElements()
{
	global $ThemeSystem;
	global $Settings;

	$content = '';
	$stylesheet = '';
	$script = '';
	
	$timestamp = '?' . time();

	// Preparing Stylesheets
	foreach ($ThemeSystem->GetStylesheets() as $elementStylesheet)
	{
		switch ($Settings->StylesheetsReferenceType)
		{
			case 'external':
				$stylesheet = TemplateProvider::Link(CreateInternalAddress(THEMEDIR . $elementStylesheet->Filename), 'stylesheet', 'text/css');
				break;
			case 'externaluncache':
				$stylesheet = TemplateProvider::Link(CreateInternalAddress(THEMEDIR . $elementStylesheet->Filename) . $timestamp, 'stylesheet', 'text/css');
				break;
			case 'embedded':
				$stylesheet = TemplateProvider::Style(file_get_contents(CreateInternalAddress(THEMEDIR . $elementStylesheet->Filename)));
				break;
		}
		
		if (!empty($elementStylesheet->Condition))
			$stylesheet = '<!--[' . $elementStylesheet->Condition . ']>' . $stylesheet . '<![endif]-->';
		
		$content .= $stylesheet . "\n";
	}
	
	// Preparing main script
	switch ($Settings->ScriptsReferenceType)
	{
		case 'external':
			$script = TemplateProvider::ScriptLink(CreateInternalAddress(SCRIPTSDIR . 'main.js'));
			break;
		case 'externaluncache':
			$script = TemplateProvider::ScriptLink(CreateInternalAddress(SCRIPTSDIR . 'main.js') . $timestamp);
			break;
		case 'embedded':
			$script = TemplateProvider::Script(file_get_contents(CreateInternalAddress(SCRIPTSDIR . 'main.js')));
			break;
	}
	$content .= $script . "\n";
	
	// Preparing Scripts
	foreach ($ThemeSystem->GetScripts() as $elementScript)
	{
		switch ($Settings->ScriptsReferenceType)
		{
			case 'external':
				$script = TemplateProvider::ScriptLink(CreateInternalAddress(THEMEDIR . $elementScript->Filename));
				break;
			case 'externaluncache':
				$script = TemplateProvider::ScriptLink(CreateInternalAddress(THEMEDIR . $elementScript->Filename) . $timestamp);
				break;
			case 'embedded':
				$script = TemplateProvider::Script(file_get_contents(CreateInternalAddress(THEMEDIR . $elementScript->Filename)));
				break;
		}
		
		if (!empty($elementScript->Condition))
			$script = '<!--[' . $elementScript->Condition . ']>' . $script . '<![endif]-->';
			
		$content .= $script . "\n";
	}
	
	return $content;
}



// Check current page is home page
// Return: boolean
function IsHomePage()
{
	global $ThisPage;
	
	return ($ThisPage->ID == 1);
}



// Check whether page or post selected
// Return: boolean
function IsPageOrPostSelected()
{
	global $ThisPage;
	global $ThisPost;
	
	return ($ThisPage->ID > 0 || $ThisPost->ID > 0);
}



?>