<?php

// Provide template
class TemplateProvider
{
	//  content
	public static function Content($content, $style)
	{
		global $Theme;
		
		$Theme->SetSubject('content.html');

		$ptn = array();
		$ptn[0] = '/{CONTENT}/';
		$ptn[1] = '/{CLASS}/';
		
		$rlc = array();
		$rlc[0] = $content;
		$rlc[1] = $style;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  content author
	public static function ContentAuthor($author)
	{
		global $Theme;
		
		$Theme->SetSubject('contentauthor.html');

		$ptn = array();
		$ptn[0] = '/{AUTHOR}/';
		
		$rlc = array();
		$rlc[0] = $author;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  content date
	public static function ContentDate($createdlong, $createdshort, $modifiedlong, $modifiedshort, $createdtime, $modifiedtime)
	{
		
		global $Theme;
		
		$Theme->SetSubject('contentdate.html');

		$ptn = array();
		$ptn[0] = '/{CREATEDLONGDATE}/';
		$ptn[1] = '/{CREATEDSHORTDATE}/';
		$ptn[2] = '/{MODIFIEDLONGDATE}/';
		$ptn[3] = '/{MODIFIEDSHORTDATE}/';
		$ptn[4] = '/{CREATEDTIME}/';
		$ptn[5] = '/{MODIFIEDTIME}/';
		
		$rlc = array();
		$rlc[0] = $createdlong;
		$rlc[1] = $createdshort;
		$rlc[2] = $modifiedlong;
		$rlc[3] = $modifiedshort;
		$rlc[4] = $createdtime;
		$rlc[5] = $modifiedtime;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  content description
	public static function ContentDescription($description)
	{
		global $Theme;

		$Theme->SetSubject('contentdescription.html');

		$ptn = array();
		$ptn[0] = '/{DESCRIPTION}/';
		
		$rlc = array();
		$rlc[0] = $description;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  content text
	public static function ContentText($text)
	{
		global $Theme;

		$Theme->SetSubject('contenttext.html');

		$ptn = array();
		$ptn[0] = '/{TEXT}/';
		
		$rlc = array();
		$rlc[0] = $text;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  `page not found`
	public static function PageNotFound($name, $title, $email)
	{
		global $Theme;

		$Theme->SetSubject('pagenotfound.html');

		$ptn = array();
		$ptn[0] = '/{NAME}/';
		$ptn[1] = '/{TITLE}/';
		$ptn[2] = '/{EMAIL}/';
		
		$rlc = array();
		$rlc[0] = $name;
		$rlc[1] = $title;
		$rlc[2] = $email;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  information message
	public static function Message($message)
	{
		global $Theme;

		$Theme->SetSubject('message.html');
		
		$ptn = array();
		$ptn[0] = '/{MESSAGE}/';
		
		$rlc = array();
		$rlc[0] = $message;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  error message
	public static function Error($message)
	{
		global $Theme;

		$Theme->SetSubject('error.html');

		$ptn = array();
		$ptn[0] = '/{MESSAGE}/';
		
		$rlc = array();
		$rlc[0] = $message;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  content parent description
	public static function ContentParentDescription($pdes)
	{
		global $Theme;

		$Theme->SetSubject('contentparentdescription.html');

		$ptn = array();
		$ptn[0] = '/{DESCRIPTION}/';
		
		$rlc = array();
		$rlc[0] = $pdes;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  subpage container
	public static function ContentSubpageContainer($subpages)
	{
		global $Theme;

		$Theme->SetSubject('subpagecontainer.html');

		$ptn = array();
		$ptn[0] = '/{SUBPAGE}/';
		
		$rlc = array();
		$rlc[0] = $subpages;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  subpage
	public static function ContentSubpage($uri, $title, $description)
	{
		global $Theme;

		$Theme->SetSubject('subpage.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{URI}/';
			$ptn[1] = '/{TITLE}/';
			$ptn[2] = '/{DESCRIPTION}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $uri;
		$values[1] = $title;
		$values[2] = $description;
		$Theme->SetCollection($values);
		
		return $Theme->RenderByCollection();
	}
	
	
	
	//  comment container
	public static function CommentContainer($comments)
	{
		global $Theme;

		$Theme->SetSubject('commentcontainer.html');

		$ptn = array();
		$ptn[0] = '/{COMMENT}/';
		
		$rlc = array();
		$rlc[0] = $comments;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  comment
	public static function Comment($namep, $subject, $message, $cdate)
	{
		global $Theme;

		$Theme->SetSubject('comment.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{NAME}/';
			$ptn[1] = '/{SUBJECT}/';
			$ptn[2] = '/{DATE}/';
			$ptn[3] = '/{MESSAGE}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $namep;
		$values[1] = $subject;
		$values[2] = $cdate;
		$values[3] = $message;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	//  comment feedback
	public static function CommentFeedback($namep, $email, $subject, $message, $cdate)
	{
		global $Theme;

		$Theme->SetSubject('commentfeedback.html');

		$ptn = array();
		$ptn[0] = '/{NAME}/';
		$ptn[1] = '/{SUBJECT}/';
		$ptn[2] = '/{DATE}/';
		$ptn[3] = '/{MESSAGE}/';
		$ptn[4] = '/{EMAIL}/';
		
		$rlc = array();
		$rlc[0] = $namep;
		$rlc[1] = $subject;
		$rlc[2] = $cdate;
		$rlc[3] = $message;
		$rlc[4] = $email;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  menu container
	public static function MenuContainer($menus)
	{
		global $Theme;

		$Theme->SetSubject('menucontainer.html');
		
		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{MENU}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $menus;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	//  menu
	public static function Menu($title, $alttext, $pageURL, $target, $style = '')
	{
		global $Theme;

		$Theme->SetSubject('menu.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{PAGEURL}/';
			$ptn[1] = '/{TITLE}/';
			$ptn[2] = '/{ALTTEXT}/';
			$ptn[3] = '/{TARGET}/';
			$ptn[4] = '/{CLASS}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $pageURL;
		$values[1] = $title;
		$values[2] = $alttext;
		$values[3] = $target;
		$values[4] = $style;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	//  panel container
	public static function PanelContainer($panels)
	{
		global $Theme;

		$Theme->SetSubject('panelcontainer.html');
		
		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{PANEL}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $panels;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	//  panel
	public static function Panel($title, $text, $style)
	{
		global $Theme;

		$Theme->SetSubject('panel.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{TITLE}/';
			$ptn[1] = '/{TEXT}/';
			$ptn[2] = '/{CLASS}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $title;
		$values[1] = $text;
		$values[2] = $style;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	//  navigator container
	public static function NavigatorContainer($navs)
	{
		global $Theme;

		$Theme->SetSubject('navigatorcontainer.html');

		$ptn = array();
		$ptn[0] = '/{NAVIGATOR}/';
		
		$rlc = array();
		$rlc[0] = $navs;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  navigator
	public static function Navigator($pageURL, $title)
	{
		global $Theme;

		$Theme->SetSubject('navigator.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{PAGEURL}/';
			$ptn[1] = '/{TITLE}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $pageURL;
		$values[1] = $title;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	//  search
	public static function Search($name, $title, $description)
	{
		global $Theme;

		$Theme->SetSubject('search.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{NAME}/';
			$ptn[1] = '/{TITLE}/';
			$ptn[2] = '/{DESCRIPTION}/';

			$Theme->CreateCollection($ptn);
		}

		$values = array();
		$values[0] = $name;
		$values[1] = $title;
		$values[2] = $description;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	//  search container
	public static function SearchContainer($skeyword, $totalCounter, $pagesCounter, $postsCounter, $searchPagesContent, $searchPostsContent)
	{
		global $Theme;

		$Theme->SetSubject('searchcontainer.html');

		$ptn = array();
		$ptn[0] = '/{KEYWORD}/';
		$ptn[1] = '/{TOTALCOUNTER}/';
		$ptn[2] = '/{PAGESCOUNTER}/';
		$ptn[3] = '/{POSTSCOUNTER}/';
		$ptn[4] = '/{SEARCHPAGESCONTENT}/';
		$ptn[5] = '/{SEARCHPOSTSCONTENT}/';
		
		$rlc = array();
		$rlc[0] = $skeyword;
		$rlc[1] = $totalCounter;
		$rlc[2] = $pagesCounter;
		$rlc[3] = $postsCounter;
		$rlc[4] = $searchPagesContent;
		$rlc[5] = $searchPostsContent;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	// Form comment form
	public static function FormComment($pID)
	{
		global $Theme;

		$Theme->SetSubject('comment.html');

		$ptn = array();
		$ptn[0] = '/{PAGEID}/';
		
		$rlc = array();
		$rlc[0] = $pID;
		
		return $Theme->RenderByFile($ptn, $rlc, FORMSDIR);
	}
	
	
	
	// Form search form
	public static function FormSearch($title, $message)
	{
		global $Theme;

		$Theme->SetSubject('search.html');

		$ptn = array();
		$ptn[0] = '/{TITLE}/';
		$ptn[1] = '/{MESSAGE}/';
		
		$rlc = array();
		$rlc[0] = $title;
		$rlc[1] = $message;
		
		return $Theme->RenderByFile($ptn, $rlc, FORMSDIR);
	}
	
	
	
	//  meta
	public static function Meta($name, $content)
	{
		global $Theme;

		$Theme->SetSubject('meta.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{NAME}/';
			$ptn[1] = '/{CONTENT}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $name;
		$values[1] = $content;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	//  meta extended
	public static function MetaExtended($name, $nameValue, $content)
	{
		global $Theme;

		$Theme->SetSubject('metaextended.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{NAME}/';
			$ptn[1] = '/{NAMEVALUE}/';
			$ptn[2] = '/{CONTENT}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $name;
		$values[1] = $nameValue;
		$values[2] = $content;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	//  link
	public static function Link($uri, $rel, $type)
	{
		global $Theme;

		$Theme->SetSubject('link.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{URI}/';
			$ptn[1] = '/{REL}/';
			$ptn[2] = '/{TYPE}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $uri;
		$values[1] = $rel;
		$values[2] = $type;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	//  style
	public static function Style($styles)
	{
		global $Theme;

		$Theme->SetSubject('style.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{STYLES}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $styles;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	//  script link
	public static function ScriptLink($uri)
	{
		global $Theme;

		$Theme->SetSubject('scriptlink.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{URI}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $uri;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	//  script
	public static function Script($scripts)
	{
		global $Theme;

		$Theme->SetSubject('script.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{SCRIPTS}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $scripts;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	//  post content
	public static function PostContent($content, $style)
	{
		global $Theme;

		$Theme->SetSubject('postcontent.html');

		$ptn = array();
		$ptn[0] = '/{CONTENT}/';
		$ptn[1] = '/{CLASS}/';
		
		$rlc = array();
		$rlc[0] = $content;
		$rlc[1] = $style;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  post content author
	public static function PostContentAuthor($author)
	{
		global $Theme;

		$Theme->SetSubject('postcontentauthor.html');

		$ptn = array();
		$ptn[0] = '/{AUTHOR}/';
		
		$rlc = array();
		$rlc[0] = $author;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  post content date
	public static function PostContentDate($createdlong, $createdshort, $modifiedlong, $modifiedshort, $createdtime, $modifiedtime)
	{
		global $Theme;

		$Theme->SetSubject('postcontentdate.html');

		$ptn = array();
		$ptn[0] = '/{CREATEDLONGDATE}/';
		$ptn[1] = '/{CREATEDSHORTDATE}/';
		$ptn[2] = '/{MODIFIEDLONGDATE}/';
		$ptn[3] = '/{MODIFIEDSHORTDATE}/';
		$ptn[4] = '/{CREATEDTIME}/';
		$ptn[5] = '/{MODIFIEDTIME}/';
		
		$rlc = array();
		$rlc[0] = $createdlong;
		$rlc[1] = $createdshort;
		$rlc[2] = $modifiedlong;
		$rlc[3] = $modifiedshort;
		$rlc[4] = $createdtime;
		$rlc[5] = $modifiedtime;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	//  post content text
	public static function PostContentText($text)
	{
		global $Theme;

		$Theme->SetSubject('postcontenttext.html');

		$ptn = array();
		$ptn[0] = '/{TEXT}/';
		
		$rlc = array();
		$rlc[0] = $text;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	// Post not found
	public static function PostNotFound($name, $title, $email)
	{
		global $Theme;

		$Theme->SetSubject('postnotfound.html');

		$ptn = array();
		$ptn[0] = '/{NAME}/';
		$ptn[1] = '/{TITLE}/';
		$ptn[2] = '/{EMAIL}/';
		
		$rlc = array();
		$rlc[0] = $name;
		$rlc[1] = $title;
		$rlc[2] = $email;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	// Posts list not found
	public static function PostsListNotFound($title, $email)
	{
		global $Theme;

		$Theme->SetSubject('postslistnotfound.html');

		$ptn = array();
		$ptn[0] = '/{TITLE}/';
		$ptn[1] = '/{EMAIL}/';
		
		$rlc = array();
		$rlc[0] = $title;
		$rlc[1] = $email;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	// Posts list contianer
	public static function PostsListContainer($posts)
	{
		global $Theme;

		$Theme->SetSubject('postslistcontainer.html');

		$ptn = array();
		$ptn[0] = '/{POSTS}/';
		
		$rlc = array();
		$rlc[0] = $posts;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	// Posts list item
	public static function PostsListItem($uri, $title, $postDate, $content)
	{
		global $Theme;

		$Theme->SetSubject('postslistitem.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{URI}/';
			$ptn[1] = '/{TITLE}/';
			$ptn[2] = '/{DATE}/';
			$ptn[3] = '/{CONTENT}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $uri;
		$values[1] = $title;
		$values[2] = $postDate;
		$values[3] = $content;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	// Posts list item date
	public static function PostsListItemDate($createdlong, $createdshort, $modifiedlong, $modifiedshort, $createdtime, $modifiedtime)
	{
		global $Theme;

		$Theme->SetSubject('postslistitemdate.html');

		$ptn = array();
		$ptn[0] = '/{CREATEDLONGDATE}/';
		$ptn[1] = '/{CREATEDSHORTDATE}/';
		$ptn[2] = '/{MODIFIEDLONGDATE}/';
		$ptn[3] = '/{MODIFIEDSHORTDATE}/';
		$ptn[4] = '/{CREATEDTIME}/';
		$ptn[5] = '/{MODIFIEDTIME}/';
		
		$rlc = array();
		$rlc[0] = $createdlong;
		$rlc[1] = $createdshort;
		$rlc[2] = $modifiedlong;
		$rlc[3] = $modifiedshort;
		$rlc[4] = $createdtime;
		$rlc[5] = $modifiedtime;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	// Posts list item more
	public static function PostsListItemMore($uri)
	{
		global $Theme;

		$Theme->SetSubject('postslistitemmore.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{URI}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $uri;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	// Posts pagination container
	public static function PostsPaginationContainer($content)
	{
		global $Theme;

		$Theme->SetSubject('postspaginationcontainer.html');

		$ptn = array();
		$ptn[0] = '/{CONTENT}/';
		
		$rlc = array();
		$rlc[0] = $content;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	// Posts pagination item
	public static function PostsPaginationItem($uri, $title, $content, $styleClass)
	{
		global $Theme;

		$Theme->SetSubject('postspaginationitem.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{URI}/';
			$ptn[1] = '/{TITLE}/';
			$ptn[2] = '/{CONTENT}/';
			$ptn[3] = '/{CLASS}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $uri;
		$values[1] = $title;
		$values[2] = $content;
		$values[3] = $styleClass;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
	
	
	// Posts pagination dots
	public static function PostsPaginationDots()
	{
		global $Theme;

		$Theme->SetSubject('postspaginationdots.html');

		$ptn = array();	
		$rlc = array();
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	// Post read more
	public static function PostReadMore()
	{
		global $Theme;

		$Theme->SetSubject('readmore.html');

		$ptn = array();	
		$rlc = array();
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	// Syndication
	public static function Syndication($title, $url, $email, $content)
	{
		global $Theme;

		$Theme->SetSubject('syndication.html');

		$ptn = array();
		$ptn[0] = '/{TITLE}/';
		$ptn[1] = '/{URL}/';
		$ptn[2] = '/{EMAIL}/';
		$ptn[3] = '/{CONTENT}/';
		
		$rlc = array();
		$rlc[0] = $title;
		$rlc[1] = $url;
		$rlc[2] = $email;
		$rlc[3] = $content;
		
		return $Theme->RenderByFile($ptn, $rlc);
	}
	
	
	
	// Syndication item
	public static function SyndicationItem($title, $link, $content)
	{
		global $Theme;

		$Theme->SetSubject('syndicationitem.html');

		if ($Theme->CollectionExists() == FALSE)
		{
			$ptn = array();
			$ptn[0] = '/{TITLE}/';
			$ptn[1] = '/{LINK}/';
			$ptn[2] = '/{CONTENT}/';

			$Theme->CreateCollection($ptn);
		}
		
		$values = array();
		$values[0] = $title;
		$values[1] = $link;
		$values[2] = $content;
		$Theme->SetCollection($values);

		return $Theme->RenderByCollection();
	}
	
}

?>