<?php

// Theme Management class
class ThemeManagement
{
	private $subject;  /* Style name */	
	private $collection = array(
		"TEMPLATE" => array(),
		"DATAS" => array()
	);                 /* Style collections */
	
	
	
	
	
	public function __construct()
	{
		global $Data;
		
		$Data['ThemeDir'] = THEMEDIR;
	}
	
	function __destruct()
	{
		unset($collection);
	}
	
	
	
	// Render by string content
	// Parameters: string, array, array
	// Return: string
	public function RenderByContent($content, $pattern, $replacement)
	{
		return preg_replace($pattern, $replacement, $content);
	}
	
	
	
	// Render by file
	// Parameters: array, array, string
	// Return: string
	public function RenderByFile($pattern, $replacement, $subjectFolder = '')
	{
		if (empty($subjectFolder) == TRUE)
			return $this->RenderByContent(file_get_contents($this->GetTemplateFile()), $pattern, $replacement);
		else
			return $this->RenderByContent(file_get_contents($this->GetTemplateFile($subjectFolder)), $pattern, $replacement);
	}
	
	
	
	// Render by collection
	// Parameters: string, array, array
	// Return: string
	public function RenderByCollection()
	{
		return $this->RenderByContent(
			$this->collection["TEMPLATE"][$this->subject], 
			$this->collection["DATAS"][$this->subject]["PATTERN"], 
			$this->collection["DATAS"][$this->subject]["REPLACEMENT"]
		);
	}
	
	
	
	// Get template file
	// Parameters: string
	// Return: string
	public function GetTemplateFile($folder = '')
	{
		if (empty($folder) == TRUE)
			return TEMPLATESDIR . $this->subject;
		else
			return $folder . '/' . $this->subject;
	}
	
	
	
	// Is any key value exists in collections
	public function CollectionExists()
	{
		return array_key_exists($this->subject, $this->collection["DATAS"]) && array_key_exists($this->subject, $this->collection["TEMPLATE"]);
	}
	
	
	
	// Create a TEMPLATE & DATAS collection
	// Parameters: array
	public function CreateCollection($ptn)
	{
		$rlc = array();
		for ($counter = 0; $counter < count($ptn); $counter++)
			$rlc[] = '';
		
		// Create DATAS collection
		$this->collection["DATAS"][$this->subject] = array(
			"PATTERN" => $ptn,
			"REPLACEMENT" => $rlc
		);
		
		// Create TEMPLATE collection
		$this->collection["TEMPLATE"][$this->subject] = file_get_contents($this->GetTemplateFile());
	}
	
	
	
	// Set collection values
	// Parameters: array
	public function SetCollection($values)
	{
		for ($counter = 0; $counter < count($values); $counter++)
			$this->collection["DATAS"][$this->subject]["REPLACEMENT"][$counter] = $values[$counter];
	}
	
	
	
	// Set subject
	// Parameters: string
	public function SetSubject($subjectName)
	{
		$this->subject = $subjectName;
	}
	
	
	
	// Get subject
	// Return: string
	public function GetSubject()
	{
		return $this->subject;
	}
	
	
	
	
	
	// Perform Render
	// Return: string
	public function PerformRender()
	{
		global $Output;
		global $Data;
		
		if (ob_start() != TRUE)
			ShowError('Error', 'Rendering Error', 'Can\'t buffer output for rendering.');
		include(THEMEDIR . 'theme.html');
		$CONTENT = ob_get_contents();
		ob_end_clean();
		
		$pattern = array();
		$pattern[0] = '/{URI}/';
		$pattern[1] = '/{MENU1}/';
		$pattern[2] = '/{MENU2}/';
		$pattern[3] = '/{MENU3}/';
		$pattern[4] = '/{MENU4}/';
		$pattern[5] = '/{MENU5}/';
		$pattern[6] = '/{NAVIGATOR}/';
		$pattern[7] = '/{PANEL1}/';
		$pattern[8] = '/{PANEL2}/';
		$pattern[9] = '/{PANEL3}/';
		$pattern[10] = '/{PANEL4}/';
		$pattern[11] = '/{PANEL5}/';
		$pattern[12] = '/{COMMENT}/';
		$pattern[13] = '/{CONTENT}/';
		$pattern[14] = '/{HEADER}/';
		$pattern[15] = '/{TITLE}/';
		$pattern[16] = '/{PAGETITLE}/';
		$pattern[17] = '/{DATE}/';
		$pattern[18] = '/{YEAR}/';
		
		$replacement = array();
		$replacement[0] = $Data['SiteUrl'];
		$replacement[1] = $Output['Menu1'];
		$replacement[2] = $Output['Menu2'];
		$replacement[3] = $Output['Menu3'];
		$replacement[4] = $Output['Menu4'];
		$replacement[5] = $Output['Menu5'];
		$replacement[6] = $Output['Navigator'];
		$replacement[7] = $Output['Panel1'];
		$replacement[8] = $Output['Panel2'];
		$replacement[9] = $Output['Panel3'];
		$replacement[10] = $Output['Panel4'];
		$replacement[11] = $Output['Panel5'];
		$replacement[12] = $Output['Comment'];
		$replacement[13] = $Output['Content'];
		$replacement[14] = $Output['Header'];
		$replacement[15] = $Output['Title'];
		$replacement[16] = $Output['PageTitle'];
		$replacement[17] = $Output['Date'];
		$replacement[18] = $Output['Year'];
		
		$CONTENT = $this->RenderByContent($CONTENT, $pattern, $replacement);
		
		return $CONTENT;
	}

}

?>