<?php
//------------------------------------------------------------
//------------------------------------------------------------
//------------------------------------------------------------
//---                                                      ---
//---  Exsense Dynamix CMS                                 ---
//---  Copyright (C) 2011-2014 Exsense Software            ---
//---  License: Exsense Open Source License                ---
//---  http://www.exsense-software.com                     ---
//---  All rights reserved for Exsense Software            ---
//---                                                      ---
//------------------------------------------------------------
//------------------------------------------------------------
//------------------------------------------------------------



// define dynamix runtime name
define('RUNTIME', 'CMS');



error_reporting(0);



// Request fields
$RequestType = '';  // Enum: PAGE | SEARCH | OPTION
$Request = '';      // Type: string | int

// Master fields
$Settings = NULL;
$Database = NULL;
$Entity = NULL;
$Modules = NULL;
$Theme = NULL;
$ThisPage = NULL;
$ThisPost = NULL;



// Load essential libraries
require_once('components/core.lib.php');
require_once('components/kernel.lib.php');
// Load libraries
require_once('components/common.lib.php');
require_once('components/configsystem.class.php');
require_once('components/database/databasesystem.class.php');
require_once('components/database/queryprovider.class.php');
require_once('components/database/commandprovider.class.php');
require_once('components/entitysystem.class.php');
require_once('components/entities.lib.php');
require_once('components/contentprovider.class.php');
require_once('components/optionprovider.class.php');
require_once('components/modulesystem.class.php');
require_once('components/thememanagement.class.php');
require_once('components/themesystem.class.php');
require_once('components/templateprovider.class.php');



register_shutdown_function('Shutdown');



// Output collection
$Output = array();
$Output['Menu1'] = '';
$Output['Menu2'] = '';
$Output['Menu3'] = '';
$Output['Menu4'] = '';
$Output['Menu5'] = '';
$Output['Navigator'] = '';
$Output['Panel1'] = '';
$Output['Panel2'] = '';
$Output['Panel3'] = '';
$Output['Panel4'] = '';
$Output['Panel5'] = '';
$Output['Comment'] = '';
$Output['Content'] = '';
$Output['Header'] = '';
$Output['Title'] = '';
$Output['PageTitle'] = '';
$Output['Date'] = '';
$Output['Year'] = '';

// Data collection
$Data = array();
$Data['HasContent'] = FALSE;
$Data['HasComment'] = FALSE;
$Data['CommentCount'] = 0;
$Data['HasSubpage'] = FALSE;
$Data['SubpageCount'] = 0;
$Data['HasPanel1'] = FALSE;
$Data['HasPanel2'] = FALSE;
$Data['HasPanel3'] = FALSE;
$Data['HasPanel4'] = FALSE;
$Data['HasPanel5'] = FALSE;
$Data['HasMenu1'] = FALSE;
$Data['HasMenu2'] = FALSE;
$Data['HasMenu3'] = FALSE;
$Data['HasMenu4'] = FALSE;
$Data['HasMenu5'] = FALSE;
$Data['SiteUrl'] = '';
$Data['ThemeDir'] = '';

$Store = array();
$Store['Author'] = '';
$Store['Description'] = '';
$Store['Keywords'] = '';



// Call temporary function
Temp_();


// Retrieve request
InitRequest();
PrepareRequest();

PrepareSiteUrl();



// Instantiate setting management class
$Settings = new SettingsManagement();
if ($Settings->HasError())
	ShowError('Error', 'Configuration File Error', 'Error in configuration and settings file.<br />Can\'t access and read configuration file.', 20);
$Settings->Load();


ContentProvider::Title();


// Check for offline mode
if ($Settings->Offline == TRUE)
	ShowMessage('', 'Offline', $Settings->OfflineMessage);


// Check database settings are valid
if (!CheckDatabaseSettings())
	ShowError('Error', 'Database Settings Error', 'Database settings doesn\'t exists or aren\'t valid', 23);


// Instantiate database management class
$Database = new DatabaseManagement($Settings->DatabaseType, $Settings->DatabaseHost, $Settings->DatabaseUsername, $Settings->DatabasePassword);
if ($Database->HasError())
	ShowError('Error', 'Database Error', 'Error in database connection.<br /><br /><strong>Error Message:</strong><br />' . $Database->ErrorMessage(), 30);
// Select the database
$Database->SelectDatabase($Settings->DatabaseName);
if ($Database->HasError())
	ShowError('Error', 'Database Error', 'Error in database selection.<br /><br /><strong>Error Message:</strong><br />' . $Database->ErrorMessage(), 35);


// Instantiate entity management class
$Entity = new EntityManagement();


// Instantiate module management class
$Modules = new ModuleManagement();
if ($Modules->HasError())
	ShowError('Error', 'Module File Error', 'Error in module configuration file.<br />Can\'t access and read module configuration file.', 50);
$Modules->Load();


// Instantiate theme management class
$Theme = new ThemeManagement();


// Instantiate theme system class
$ThemeSystem = new ThemeSystem();
if ($ThemeSystem->HasError())
	ShowError('Error', 'Theme Elements File Error', 'Error in theme elements file.<br />Can\'t access and read theme elements file.', 80);
$ThemeSystem->Load();


// Instantiate this page & this post entity classes
$ThisPage = new ThisPageClass();
$ThisPost = new ThisPostClass();



// Manage requests
switch ($RequestType)
{
	case 'PAGE':
		ContentProvider::Page();
		break;
	case 'POST':
		ContentProvider::Post();
		break;
	case 'POSTS':
		ContentProvider::Posts();
		break;
	case 'SEARCH':
		ContentProvider::Search();
		break;
	case 'OPTION':
		switch ($Request)
		{
			case 'comment':
				OptionProvider::CommentFeedback();
				break;
			case 'syndication':
				OptionProvider::Syndication();
				break;
			case 'theme':
				OptionProvider::ThemeOutline();
				break;
			default:
				ContentProvider::PageNotFound();
				break;
		}
		break;
	default:
		ContentProvider::PageNotFound();
		break;
}

ContentProvider::Header();
ContentProvider::Menu();
ContentProvider::Panel();
ContentProvider::Navigator();


// Check is error occured and perform desire action
CheckErrorOccured();


// Perform render theme
echo $Theme->PerformRender();


// Unset and remove collections and objects
unset($Settings);
unset($Database);
unset($Entity);
unset($Modules);
unset($ThemeSystem);
unset($Theme);
unset($Output);
unset($Data);
unset($Store);
unset($ThisPage);
unset($ThisPost);

?>