-- ================================ --
--  Exsense Dynamix                 --
--  Copyright (C) Exsense Software  --
-- ================================ --

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

CREATE DATABASE IF NOT EXISTS `{DATABASE}` DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;

USE `{DATABASE}`;

DROP TABLE IF EXISTS `comment`;
DROP TABLE IF EXISTS `menu`;
DROP TABLE IF EXISTS `page`;
DROP TABLE IF EXISTS `panel`;
DROP TABLE IF EXISTS `post`;
DROP TABLE IF EXISTS `contents`;



CREATE TABLE `page` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ParentID` int(10) unsigned NOT NULL DEFAULT '0',
  `Name` varchar(255) NOT NULL COMMENT 'lower case',
  `Title` varchar(255) NOT NULL,
  `Description` text,
  `TextContent` mediumtext NOT NULL,
  `CreatedDate` datetime NOT NULL,
  `ModifiedDate` datetime NOT NULL,
  `Published` tinyint(1) NOT NULL DEFAULT '1',
  `Counter` bigint(20) unsigned NOT NULL DEFAULT '0',
  `AllowCommenting` tinyint(1) NOT NULL DEFAULT '0',
  `ShowComments` tinyint(1) NOT NULL DEFAULT '0',
  `ShowSubpages` tinyint(1) NOT NULL DEFAULT '1',
  `ShowTitle` tinyint(1) NOT NULL DEFAULT '1',
  `ShowDescription` tinyint(1) NOT NULL DEFAULT '1',
  `ShowDate` tinyint(1) NOT NULL DEFAULT '1',
  `ShowAuthor` tinyint(1) NOT NULL DEFAULT '1',
  `Author` varchar(50) DEFAULT NULL,
  `MetaDescription` varchar(255) DEFAULT NULL,
  `MetaKeywords` varchar(255) DEFAULT NULL,
  `StyleClass` varchar(255) DEFAULT NULL,
  `ExData` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `Name` (`Name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

CREATE TABLE `post` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) NOT NULL COMMENT 'lower case',
  `Title` varchar(255) NOT NULL,
  `TextContent` mediumtext NOT NULL,
  `CreatedDate` datetime NOT NULL,
  `ModifiedDate` datetime NOT NULL,
  `Published` tinyint(1) NOT NULL DEFAULT '1',
  `Counter` bigint(20) unsigned NOT NULL DEFAULT '0',
  `ShowAuthor` tinyint(1) NOT NULL DEFAULT '1',
  `Author` varchar(50) DEFAULT NULL,
  `MetaDescription` varchar(255) DEFAULT NULL,
  `MetaKeywords` varchar(255) DEFAULT NULL,
  `StyleClass` varchar(255) DEFAULT NULL,
  `ExData` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `Name` (`Name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE `panel` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `PageID` int(10) unsigned NOT NULL DEFAULT '1',
  `PanelGroup` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Values: 1,2,3,4,5',
  `Title` varchar(255) NOT NULL,
  `TextContent` text,
  `ShowOnSubpages` tinyint(1) NOT NULL DEFAULT '0',
  `ShowGlobal` tinyint(1) NOT NULL DEFAULT '0',
  `StyleClass` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE `comment` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `PageID` int(10) unsigned NOT NULL,
  `NamePerson` varchar(50) NOT NULL,
  `Email` varchar(100) DEFAULT NULL,
  `Subject` varchar(255) DEFAULT NULL,
  `Message` text NOT NULL,
  `CreatedDate` datetime NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE `menu` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `MenuGroup` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Values: 1,2,3,4,5',
  `Title` varchar(50) NOT NULL,
  `AltText` varchar(255) DEFAULT NULL,
  `PageURL` varchar(500) NOT NULL,
  `Ordering` int(10) unsigned NOT NULL DEFAULT '0',
  `Published` tinyint(1) NOT NULL DEFAULT '1',
  `IsExternal` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;



INSERT INTO `page` (`ID`, `ParentID`, `Name`, `Title`, `Description`, `TextContent`, `CreatedDate`, `ModifiedDate`, `Published`, `Counter`, `AllowCommenting`, `ShowComments`, `ShowSubpages`, `ShowTitle`, `ShowDescription`, `ShowDate`, `ShowAuthor`, `Author`, `MetaDescription`, `MetaKeywords`, `StyleClass`) VALUES
(1, 0, 'home', 'Home', 'home page', 'home page', now(), now(), 1, 0, 0, 0, 0, 1, 0, 1, 1, 'Exsense Software', 'Exsense Dynamix', 'Exsense Dynamix, Home Page', NULL);



CREATE VIEW `contents` AS
select `page`.`ID` AS `ID`, `page`.`Name` AS `Name`, `page`.`Title` AS `Title`, `page`.`TextContent` AS `TextContent`, `page`.`CreatedDate` AS `CreatedDate`, `page`.`ModifiedDate` AS `ModifiedDate`, `page`.`Published` AS `Published`, 'PAGE' AS `Category` from `page`
union
select `post`.`ID` AS `ID`, `post`.`Name` AS `Name`, `post`.`Title` AS `Title`, `post`.`TextContent` AS `TextContent`, `post`.`CreatedDate` AS `CreatedDate`, `post`.`ModifiedDate` AS `ModifiedDate`, `post`.`Published` AS `Published`, 'POST' AS `Category` from `post`;



/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;